
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class GamesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const games = await db.games.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        genre: data.genre
        ||
        null
            ,
            
        difficulty: data.difficulty
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        game_url: data.game_url
        ||
        null
            ,
            
        time_limit_seconds: data.time_limit_seconds
        ||
        null
            ,
            
        multiplayer: data.multiplayer
        ||
        false
        
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await games.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.games.getTableName(),
                belongsToColumn: 'thumbnail',
                belongsToId: games.id,
            },
            data.thumbnail,
            options,
        );
        

        return games;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const gamesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                genre: item.genre
            ||
            null
            ,
            
                difficulty: item.difficulty
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                game_url: item.game_url
            ||
            null
            ,
            
                time_limit_seconds: item.time_limit_seconds
            ||
            null
            ,
            
                multiplayer: item.multiplayer
            ||
            false
        
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const games = await db.games.bulkCreate(gamesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < games.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.games.getTableName(),
                    belongsToColumn: 'thumbnail',
                    belongsToId: games[i].id,
                },
                data[i].thumbnail,
                options,
            );
        }
        

        return games;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const games = await db.games.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.genre !== undefined) updatePayload.genre = data.genre;
        
        
        if (data.difficulty !== undefined) updatePayload.difficulty = data.difficulty;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.game_url !== undefined) updatePayload.game_url = data.game_url;
        
        
        if (data.time_limit_seconds !== undefined) updatePayload.time_limit_seconds = data.time_limit_seconds;
        
        
        if (data.multiplayer !== undefined) updatePayload.multiplayer = data.multiplayer;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await games.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await games.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.games.getTableName(),
                belongsToColumn: 'thumbnail',
                belongsToId: games.id,
            },
            data.thumbnail,
            options,
        );
        

        return games;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const games = await db.games.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of games) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of games) {
                await record.destroy({transaction});
            }
        });


        return games;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const games = await db.games.findByPk(id, options);

        await games.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await games.destroy({
            transaction
        });

        return games;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const games = await db.games.findOne(
            { where },
            { transaction },
        );

        if (!games) {
            return games;
        }

        const output = games.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.content_items_game = await games.getContent_items_game({
            transaction
        });
        
        
        
        
        
        output.attempts_game = await games.getAttempts_game({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.thumbnail = await games.getThumbnail({
            transaction
        });
        
        
        output.organizations = await games.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'thumbnail',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'games',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'games',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.game_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'games',
                        'game_url',
                        filter.game_url,
                    ),
                };
            }
            

            
            

            
            if (filter.time_limit_secondsRange) {
                const [start, end] = filter.time_limit_secondsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    time_limit_seconds: {
                    ...where.time_limit_seconds,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    time_limit_seconds: {
                    ...where.time_limit_seconds,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.genre) {
                where = {
                    ...where,
                genre: filter.genre,
            };
            }
            
            if (filter.difficulty) {
                where = {
                    ...where,
                difficulty: filter.difficulty,
            };
            }
            
            if (filter.multiplayer) {
                where = {
                    ...where,
                multiplayer: filter.multiplayer,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.games.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'games',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.games.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

